#include <stdio.h>
#include <unistd.h>
#include <sys/msg.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/wait.h>
#include <errno.h>
#include <string.h>
#include "mensaje.h"

#define CANT_CATALIZADORES 3
#define OFFSET_MENSAJE TIPO_C + 1

int main() {

	key_t clave_cola;
	pid_t pid_catalizador;
	int mqid;
	int indice;
	mensaje msg;

	// Key
	clave_cola = ftok(".", 'a');

	// Handler cola existente
	mqid = msgget(clave_cola, 0);

	if (mqid < 0) {
		printf("Error al vincularse a la cola: %s\n", strerror(errno));
		return -1; // Codigo general de error
	}

	// Creacion de los catalizadores
	for (indice = 0; indice < CANT_CATALIZADORES; indice ++) {
		pid_catalizador = fork();
		if (pid_catalizador == 0) break;
	}

	if (pid_catalizador == 0) { // Catalizador i-esimo		
		while(1) {
			printf("Catalizador %i, aguardo por mi turno\n", indice);
			msgrcv(mqid, &msg, TAM_MENSAJE, indice+OFFSET_MENSAJE, 0);
			printf("Catalizador %i, aguardo por A\n", indice);
			msgrcv(mqid, &msg, TAM_MENSAJE, TIPO_A, 0);
			printf("Catalizador %i, aguardo por B\n", indice);
			msgrcv(mqid, &msg, TAM_MENSAJE, TIPO_B, 0);
			printf("Catalizador %i, aguardo por C\n", indice);
			msgrcv(mqid, &msg, TAM_MENSAJE, TIPO_C, 0);
			printf("Catalizador %i, finalizo\n", indice);
			// Senal al proximo catalizador
			msg.tipo = ((indice + 1) % CANT_CATALIZADORES) + OFFSET_MENSAJE;			
			msgsnd(mqid, &msg, TAM_MENSAJE, 0);
		}

	} else { // Supercatalizador
		// Senal al primer catalizador
		msg.tipo = OFFSET_MENSAJE;
		msgsnd(mqid, &msg, TAM_MENSAJE, 0);
		// Aguarda por la finalizacion de los catalizadores
		for (indice = 0; indice < CANT_CATALIZADORES; indice++) {
			wait(NULL);
		}
	}
}